#include "Arduino.h"
#include "HardwareTimer.h"
//#include <SoftwareSerial.h>
//SoftwareSerial GT(PA9, PA10); // RX, TX
#include <Wire.h>
#define Kp 0.2
#define Ki 0.008
#define Kd 0.0005
const float T = 0.1;
float E, E1, E2;
float alpha, beta, gama;  // thông số PID
float Output = 0;
float tinhieu1, tinhieu2;
float LastOutput = 0;  // biến cho lần cuối cùng
float RateRoll, RatePitch, RateYaw;
float AccX, AccY, AccZ;
float accRatioRoll, angleRadRoll, accRatioPitch, angleRadPitch;
float AngleRoll, AnglePitch;
float LoopTimer;
int congy;
int gocCBx;
int fan2 = PB8;
int fan1 = PB9;

int x_n=100, y_n=0;
int x_d=0, y_d=100;
int y_d_dc,x_n_dc;
int y_d_cn=100, x_n_cn=100;

HardwareTimer timer(TIM1);
void gyro_signals(void) {
  Wire.beginTransmission(0x68);
  Wire.write(0x1A);
  Wire.write(0x05);
  Wire.endTransmission();
  Wire.beginTransmission(0x68);  // định cấu hình cho mpu6050
  Wire.write(0x1C);              // lưu trữ trong thanh ghi 1C
  Wire.write(0x10);              // 0_bit3 và 1_bit4
  Wire.endTransmission();        // đóng quá trình truyền dữ liệu và thông báo kết thúc
  Wire.beginTransmission(0x68);
  Wire.write(0x3B);
  Wire.endTransmission();
  Wire.requestFrom(0x68, 6);
  int16_t AccXLSB = Wire.read() << 8 | Wire.read();
  int16_t AccYLSB = Wire.read() << 8 | Wire.read();
  int16_t AccZLSB = Wire.read() << 8 | Wire.read();
  Wire.beginTransmission(0x68);
  Wire.write(0x1B);
  Wire.write(0x8);
  Wire.endTransmission();
  Wire.beginTransmission(0x68);
  Wire.write(0x43);
  Wire.endTransmission();
  Wire.requestFrom(0x68, 6);
  int16_t GyroX = Wire.read() << 8 | Wire.read();
  int16_t GyroY = Wire.read() << 8 | Wire.read();
  int16_t GyroZ = Wire.read() << 8 | Wire.read();
  RateRoll = (float)GyroX / 65.5;  // 65.5 chuyển đổi giá trị đọc từ cảm biến thành tốc độ góc tương ứng
  RatePitch = (float)GyroY / 65.5;
  RateYaw = (float)GyroZ / 65.5;
  AccX = (float)AccXLSB / 4096;  // chọn AFS_SEL = 2 nên độ nhạy LSB 4096
  AccY = (float)AccYLSB / 4096;  // chuyển đổi giá trị sang đơn vị g
  AccZ = (float)AccZLSB / 4096;

  //AngleRoll=atan(AccY/sqrt(AccX*AccX+AccZ*AccZ))*1/(3.142/180);
  accRatioRoll = AccY / sqrt(AccX * AccX + AccZ * AccZ);
  angleRadRoll = atan(accRatioRoll);
  AngleRoll = angleRadRoll * 180 / 3.142;

  //AnglePitch=-atan(AccX/sqrt(AccY*AccY+AccZ*AccZ))*1/(3.142/180);
  accRatioPitch = AccX / sqrt(AccY * AccY + AccZ * AccZ);
  angleRadPitch = -atan(accRatioPitch);
  AnglePitch = angleRadPitch * 180 / 3.142;
}

void setup() {
  Serial.begin(9600);
  Serial1.begin(9600);
 
  Wire.begin();
  Wire.beginTransmission(0x68);
  Wire.write(0x6B);
  Wire.write(0x00);
  Wire.endTransmission();
  //////////////////////////////////////

  timer.pause();
  timer.setOverflow(1000, MICROSEC_FORMAT);
  timer.attachInterrupt(timer_overflow);
  timer.resume();


  pinMode(fan1, OUTPUT);
  pinMode(fan2, OUTPUT);
}
void timer_overflow() 
{
  E = AngleRoll + gocCBx;
  alpha = 2*T*Kp + Ki*T*T + 2*Kd;
  beta = T*T*Ki - 4*Kd - 2*T*Kp;
  gama = 2*Kd;
  Output = (alpha*E + beta*E1 + gama*E2 + 2*T*LastOutput)/(2*T);
  LastOutput = Output;
  E2 = E1;
  E1 = E;
  //tinhieu1=Output;
  tinhieu1=60 + Output + congy ;
  //tinhieu1=124-Output;
if(tinhieu1<0) tinhieu1=0;
 else if (tinhieu1>=200) tinhieu1=200;
  tinhieu2=60 - Output + congy ;
  if(tinhieu2<0) tinhieu2=0;
  else if (tinhieu2>=200) tinhieu2=200;

  analogWrite(fan1,tinhieu1);
  analogWrite(fan2,tinhieu2);

}



void loop() {
  gyro_signals();
  timer_overflow();


    
  while( Serial1.available() >=2  )
  {

    y_d = Serial1.read();
    delay(1);
    x_n = Serial1.read();


    
  } 
//    x_N=100, y_N=0;
//    x_D=0, y_D=100;
   

    if( y_d> 99 && y_d<101&& x_n>99 && x_n<101){gocCBx = 0; congy = 0;}


      if(y_d<y_d_cn){
    
       // tính bước giảm của y dọc
       y_d_dc = y_d_cn - y_d;
       
       //cong y tương ứng với y dọc giảm
       congy += y_d_dc;
       
       // cập nhật giá trị y dọc đi lên
       y_d_cn = y_d;
      } 
      else{
      //kiểm tra xem y_d có tăng so với giá trị trước đó không
        if(y_d>y_d_cn){
       // tính bước tăng của y dọc
       y_d_dc = y_d - y_d_cn;
       
       //trừ y tương ứng với y dọc giảm
       congy -= y_d_dc;
       
       // cập nhật giá trị y dọc đi xuống
       y_d_cn = y_d;
      }
    }
    if(x_n>99 && x_n <101){
    if(x_n<99){gocCBx+=1;if(gocCBx>=3)gocCBx=3;}
    else if(x_n>101){gocCBx-=1;if(gocCBx<=-3)gocCBx=-3;}
    }

  }



    
